# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Mysql::Mgmt::V2017_12_01
  module Models
    #
    # The properties used to create a new server by restoring from a backup.
    #
    class ServerPropertiesForRestore < ServerPropertiesForCreate

      include MsRestAzure


      def initialize
        @createMode = "PointInTimeRestore"
      end

      attr_accessor :createMode

      # @return [String] The source server id to restore from.
      attr_accessor :source_server_id

      # @return [DateTime] Restore point creation time (ISO8601 format),
      # specifying the time to restore from.
      attr_accessor :restore_point_in_time


      #
      # Mapper for ServerPropertiesForRestore class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PointInTimeRestore',
          type: {
            name: 'Composite',
            class_name: 'ServerPropertiesForRestore',
            model_properties: {
              version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'version',
                type: {
                  name: 'String'
                }
              },
              ssl_enforcement: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sslEnforcement',
                type: {
                  name: 'Enum',
                  module: 'SslEnforcementEnum'
                }
              },
              storage_profile: {
                client_side_validation: true,
                required: false,
                serialized_name: 'storageProfile',
                type: {
                  name: 'Composite',
                  class_name: 'StorageProfile'
                }
              },
              createMode: {
                client_side_validation: true,
                required: true,
                serialized_name: 'createMode',
                type: {
                  name: 'String'
                }
              },
              source_server_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'sourceServerId',
                type: {
                  name: 'String'
                }
              },
              restore_point_in_time: {
                client_side_validation: true,
                required: true,
                serialized_name: 'restorePointInTime',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
