# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Mysql::Mgmt::V2018_06_01
  module Models
    #
    # Represents a Recommendation Action.
    #
    class RecommendationAction < ProxyResource

      include MsRestAzure

      # @return [String] Advisor name.
      attr_accessor :advisor_name

      # @return [String] Recommendation action session identifier.
      attr_accessor :session_id

      # @return [Integer] Recommendation action identifier.
      attr_accessor :action_id

      # @return [DateTime] Recommendation action creation time.
      attr_accessor :created_time

      # @return [DateTime] Recommendation action expiration time.
      attr_accessor :expiration_time

      # @return [String] Recommendation action reason.
      attr_accessor :reason

      # @return [String] Recommendation action type.
      attr_accessor :recommendation_type

      # @return [Hash{String => String}] Recommendation action details.
      attr_accessor :details


      #
      # Mapper for RecommendationAction class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RecommendationAction',
          type: {
            name: 'Composite',
            class_name: 'RecommendationAction',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              advisor_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.advisorName',
                type: {
                  name: 'String'
                }
              },
              session_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.sessionId',
                type: {
                  name: 'String'
                }
              },
              action_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.actionId',
                type: {
                  name: 'Number'
                }
              },
              created_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.createdTime',
                type: {
                  name: 'DateTime'
                }
              },
              expiration_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.expirationTime',
                type: {
                  name: 'DateTime'
                }
              },
              reason: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.reason',
                type: {
                  name: 'String'
                }
              },
              recommendation_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.recommendationType',
                type: {
                  name: 'String'
                }
              },
              details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.details',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
